apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ grafana_name }}
  name: {{ grafana_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ grafana_replicas }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ grafana_name }}
  strategy:
{% if grafana_is_readonly | default(False) %}
    type: RollingUpdate
{% else %}
    type: Recreate
{% endif %}
{% else %}
    name: {{ grafana_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
{% if grafana_is_readonly | default(False) %}
    rollingParams:
      timeoutSeconds: 1200
    type: Rolling
{% else %}
    recreateParams:
      timeoutSeconds: 1200
    type: Recreate
{% endif %}
{% endif %}
  template:
    metadata:
      labels:
        name: {{ grafana_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ grafana_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ grafana_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='grafana'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='grafana'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 39
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 3000
        name: grafana
        ports:
        - containerPort: 3000
          name: http
        readinessProbe:
          httpGet:
            path: /
            port: 3000
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ grafana_cpu_limit }}"
            memory: "{{ grafana_memory_limit }}"
          requests:
            cpu: "{{ grafana_cpu_request }}"
            memory: "{{ grafana_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 70
          initialDelaySeconds: 10
          periodSeconds: 15
          tcpSocket:
            port: 3000
{% endif %}
        volumeMounts:
{% if (grafana_do_ldap or grafana_do_lemon) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/grafana/grafana.ini
          name: config
          subPath: grafana.ini
{% if grafana_do_ldap %}
        - mountPath: /etc/grafana/ldap.toml
          name: config
          subPath: ldap.toml
{% endif %}
        - mountPath: /etc/grafana/provisioning/datasources/prometheus.yaml
          name: config
          subPath: prometheus.yaml
        - mountPath: /etc/grafana/provisioning/dashboards
          name: run
          subPath: dashboards
        - mountPath: /etc/grafana/provisioning/dashboards/ops-dashboards.yaml
          name: config
          subPath: ops-dashboards.yaml
{% if grafana_do_ldap or grafana_do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /ops-dashboards
          name: dashboards
        - mountPath: /var/lib/grafana
{% if not (grafana_is_readonly | default(False)) %}
          name: data
{% else %}
          name: run
          subPath: data
{% endif %}
        - mountPath: /var/lib/grafana/plugins
          name: run
          subPath: plugins
{% if grafana_do_ldap or grafana_do_lemon %}
{% elif grafana_do_oc %}
        - mountPath: /etc/tls/private
          name: tls
      - args:
        - -provider=openshift
        - -proxy-prefix=/oauth2
{% if oc_api_fqdn | default(False) %}
        - -login-url=https://{{ oc_api_fqdn }}/oauth/authorize
        - -redeem-url=https://kubernetes.default.svc/oauth/token
{% endif %}
        - -https-address=:8443
        - -http-address=
        - -email-domain=*
        - -upstream=http://127.0.0.1:3000
        - -tls-cert=/etc/tls/private/tls.crt
        - -tls-key=/etc/tls/private/tls.key
        - -client-id=system:serviceaccount:{{ namespace }}:{{ grafana_name }}
        - -client-secret-file=/var/run/secrets/kubernetes.io/serviceaccount/token
        - -cookie-secret-file=/etc/proxy/secrets/session_secret
        - -cookie-refresh=0
        - -cookie-expire=24h0m0s
        - -cookie-name=_oauth2_grafana
        - -skip-auth-regex=^/oauth/healthz
{% if do_triggers == False or (opsimages | json_query("[?name=='oauthproxy'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='oauthproxy'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          initialDelaySeconds: 30
          tcpSocket:
            port: 8443
          periodSeconds: 20
          timeoutSeconds: 8
        name: authproxy
        ports:
        - containerPort: 8443
        readinessProbe:
          initialDelaySeconds: 5
          httpGet:
            path: /oauth/healthz
            port: 8443
            scheme: HTTPS
          periodSeconds: 20
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ oauthproxy_cpu_limit }}"
            memory: "{{ oauthproxy_memory_limit }}"
          requests:
            cpu: "{{ oauthproxy_cpu_request }}"
            memory: "{{ oauthproxy_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /etc/tls/private
          name: tls
        - mountPath: /etc/proxy/secrets
          name: session
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if rwo_needs_fsgroup | default(False) and not (grafana_is_readonly | default(False)) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% else %}
      securityContext: {}
{% endif %}
{% if not grafana_do_lemon and not grafana_do_ldap and grafana_do_oc %}
      serviceAccountName: {{ grafana_name }}
{% else %}
      serviceAccountName: default
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ grafana_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: config
        secret:
          secretName: {{ grafana_name }}
      - name: dashboards
        projected:
          sources:
{% for dashboard_name in grafana_dashboards %}
          - configMap:
              name: {{ grafana_name }}-dashboard-{{ dashboard_name | lower | regex_replace('[^a-z0-9]', '') }}
              items:
              - key: {{ dashboard_name }}.json
                path: {{ dashboard_name }}.json
{% endfor %}
{% if not (grafana_is_readonly | default(False)) %}
      - name: data
        persistentVolumeClaim:
          claimName: {{ grafana_name }}
{% endif %}
      - emptyDir: {}
        name: run
{% if grafana_do_lemon or grafana_do_ldap %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% if (grafana_do_ldap or grafana_do_lemon) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% elif grafana_do_oc %}
      - name: session
        secret:
          secretName: {{ prometheus_name }}-oauth
      - name: tls
        secret:
          secretName: {{ grafana_name }}-cert
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='grafana'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - grafana
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='grafana'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if not grafana_do_lemon and not grafana_do_ldap and grafana_do_oc and (opsimages | json_query("[?name=='oauthproxy'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - authproxy
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='oauthproxy'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
